#include <sstream>
#include <vector>
#include <algorithm>
#include <cstring>
#include <cstdlib>
#include <iostream>
#include <string>
#include <cassert>
#include <ctime>
#include <map>
#include <math.h>
#include <cstdio>
#include <set>
#include <deque>
#include <memory.h>
#include <queue>

#pragma comment(linker, "/STACK:64000000")
typedef long long ll;

using namespace std;

const int MAXK = -1;
const int MAXN = -1;
const double PI = acos(-1.0);

vector<string> split(string a, char c) {
	vector<string> res;
	string cur = "";
	bool need = 1;
	for (int i = 0; i < (int)a.length(); i++) {
		if (a[i] == '(') need = 0;
		if (a[i] == ')') need = 1;
		if (a[i] == c && need) {
			res.push_back(cur);
			cur = "";
		}
		else {
			cur += a[i];
		}
	}
	res.push_back(cur);
	return res;
}

pair<int, ll> parseMonom(string s) {
	vector<string> a = split(s, '*');
	int pw = 0;
	ll coef = 1;
	for (int i = 0; i < (int)a.size(); i++) {
		if (a[i] == "x") pw++;
		else coef *= a[i][0] - '0';
	}
	return make_pair(pw, coef);
}

int main() {
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);

	cout.precision(15);
	cout << fixed;

	string s;
	while (cin >> s) {
		vector<string> a = split(s, '+');

		int id = -1;
		for (int i = 0; i < (int)a.size(); i++) {
			if (a[i].find("sin") != -1) {
				id = i;
			}
		}
		if (id == -1) {
			cout << 0 << endl;
			continue;
		}

		vector<ll> coefs(20);
		for (int i = 0; i < (int)a.size(); i++) {
			if (i == id) continue;
			pair<int, ll> o = parseMonom(a[i]);
			coefs[o.first] += o.second;
		}

		bool fail = 0;
		for (int i = 1; i < 20; i++) fail |= coefs[i] != 0;

		if (fail) {
			cout << 0 << endl;
			continue;
		}

		vector<string> b = split(a[id], '*');

		string c;
		for (int i = 0; i < (int)b.size(); i++) {
			if (b[i] == "0") {
				fail = 1;
			}
			if (b[i] == "x") {
				fail = 1;
			}
			if (b[i].substr(0, 3) == "sin") {
				c = b[i].substr(4, (int)b[i].length()- 5);
			}
		}

		if (fail) {
			cout << 0 << endl;
			continue;
		}

		coefs = vector<ll>(20, 0);

		vector<string> d = split(c, '+');
		for (int i = 0; i < (int)d.size(); i++) {
			pair<int, ll> o = parseMonom(d[i]);
			coefs[o.first] += o.second;
		}

		for (int i = 2; i < 20; i++) fail |= coefs[i];

		if (fail) {
			cout << 0 << endl;
			continue;
		}

		if (coefs[1] == 0) {
			cout << 0 << endl;
			continue;
		}

		cout << 2 * PI / coefs[1] << endl;
	}
	
	return 0;
}
